<template>
  <div class="group" @click="focusInput">
    <input 
      :required="required"
      :class="classType"
      :type="inputType"
      :disabled="isDisabled"
      v-model="$parent[model]"
      @blur="blurInput"
    >
    <label class="label"> {{ label }} </label>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    label: {
      type: String,
      required: true,
    },
    required: {
      type: Boolean,
      default: false,
    },
    inputStyle: {
      type: String,
      default: 'primary',
    },
    inputType: {
      type: String,
      default: 'text',
    },
    model: {
      type: String,
      required: true,
    },
  },

  data(): { [key: string]: boolean} {
    return {
      isFocused: false,
    };
  },

  computed: {
    classType(): { [key: string]: boolean } {
      const classes: { [key: string]: boolean } = {
        input: true,
      };

      const { $parent, isFocused, model, inputStyle }: any = this;

      if (isFocused || $parent[model] !== '') {
        classes[`input--${inputStyle}--focus`] = true;
      } else {
        classes[`input--${inputStyle}`] = true;
      }

      return classes;
    },

    isDisabled(): boolean {
      const { inputStyle }: any = this;
      return inputStyle === 'disabled';
    },
  },

  methods: {
    focusInput(): void {
      if (this.inputStyle === 'disabled') {
        return;
      }

      this.isFocused = true;
    },

    blurInput(): void {
      this.isFocused = false;
    },
  },
});
</script>

<style lang="postcss">
.group {
  @apply relative m-4;

  width: min-content;
}

.input {
  @apply border-2 rounded p-2 border-solid; 
}

.input:focus {
  @apply outline-none;
}

.label {
  @apply absolute text-grey-dark select-none;
  left: 0.5rem;
  top: 25%;

  transition: all 0.25s ease-out;
}

.input--primary {
  @apply border-black;
}

.input--primary--focus {
  @apply border-primary;
}

.input--primary--focus ~ .label {
  @apply text-primary bg-white border-white;

  transform: translateY(-100%) scale(.9);
}

.input--disabled {
  @apply border-grey bg-grey;
}

.input--disabled ~ .label {
  @apply text-grey-darker;
}
</style>
